import { createApp } from 'vue'

import Cookies from 'js-cookie'

import ElementPlus from 'element-plus'
import 'element-plus/dist/index.css'
import zhCn from 'element-plus/es/locale/lang/zh-cn';
import ko from 'element-plus/es/locale/lang/ko';

import { useLanguageStore } from '@/store/modules/language.js';
import i18n from '@/locales/index.js'  //导入i18n国际化

import '@/assets/styles/index.scss' // global css
import { TUIComponents, TUIChatKit } from './TUIKit';
import {
  TUIStore,
  StoreName,
  TUITranslateService,
} from '@tencentcloud/chat-uikit-engine-lite';
import TUINotification from './TUIKit/components/TUINotification/index';

import App from './App'
import store from './store'
import router from './router'
import directive from './directive' // directive

// 注册指令
import plugins from './plugins' // plugins
import { download } from '@/utils/request'

// svg图标
import 'virtual:svg-icons-register'
import SvgIcon from '@/components/SvgIcon'
import elementIcons from '@/components/SvgIcon/svgicon'

import './permission' // permission control

import { useDict } from '@/utils/dict'
import { parseTime, resetForm, addDateRange, handleTree, selectDictLabel, selectDictLabels, getNameBuyStatus, CloneData } from '@/utils/ruoyi'

// 分页组件
import Pagination from '@/components/Pagination'
// 自定义表格工具组件
import RightToolbar from '@/components/RightToolbar'
// 富文本组件
import Editor from "@/components/Editor"
import Wangeditor from '@/components/Editor/wangeditor.vue';
// 文件上传组件TinyMCEditor
import FileUpload from "@/components/FileUpload"
// 图片上传组件
import ImageUpload from "@/components/ImageUpload"
// 视频上传组件
import VideoUpload from "@/components/VideoUpload"
// 图片预览组件
import ImagePreview from "@/components/ImagePreview"
// 自定义树选择组件
import TreeSelect from '@/components/TreeSelect'
// 字典标签组件
import DictTag from '@/components/DictTag'


const app = createApp(App)

// 全局方法挂载
app.config.globalProperties.useDict = useDict
app.config.globalProperties.download = download
app.config.globalProperties.parseTime = parseTime
app.config.globalProperties.resetForm = resetForm
app.config.globalProperties.handleTree = handleTree
app.config.globalProperties.addDateRange = addDateRange
app.config.globalProperties.selectDictLabel = selectDictLabel
app.config.globalProperties.selectDictLabels = selectDictLabels
app.config.globalProperties.getNameBuyStatus = getNameBuyStatus
app.config.globalProperties.CloneData = CloneData

// 全局组件挂载
app.component('DictTag', DictTag)
app.component('Pagination', Pagination)
app.component('TreeSelect', TreeSelect)
app.component('FileUpload', FileUpload)
app.component('ImageUpload', ImageUpload)
app.component('VideoUpload', VideoUpload)
app.component('ImagePreview', ImagePreview)
app.component('RightToolbar', RightToolbar)
app.component('Wangeditor', Wangeditor)
app.component('Editor', Editor)

app.use(router)
app.use(store)
app.use(plugins)
app.use(elementIcons)
app.component('svg-icon', SvgIcon)



directive(app)

// 2.读取 Pinia 中的语言状态，同步到 i18n
const languagestore = useLanguageStore();
i18n.global.locale.value = languagestore.language;// 关键：同步语言

app.use(i18n)
// 使用element-plus 并且设置全局的大小
app.use(ElementPlus, {
    locale: languagestore.language === 'zh-CN' ? zhCn : ko,
    // 支持 large、default、small
    size: localStorage.getItem('size') || 'default'
})
app.mount('#app')

const SDKAppID = 20032025; // Your SDKAppID
const secretKey = "b69175bbbbb54678c023c3938e6773eea203fe5e2413fd25efe5e68483c834fe"; // Your secretKey

TUIChatKit.components(TUIComponents, app);
TUIChatKit.init();

// TUITranslateService.setI18next(i18next);
// TUITranslateService.provideLanguages(locales);
// TUITranslateService.useI18n();

/**
 * Init TUINotification configuration.
 */
TUINotification.setNotificationConfiguration({
  showPreviews: true,
  allowNotifications: true,
  notificationTitle: 'Tencent Cloud Chat',
  notificationIcon: 'https://web.sdk.qcloud.com/im/demo/latest/faviconnew.png',
});

/**
 * Listen for new messages and use notification components.
 * This capability is only available in the web environment.
 */
// TUIStore.watch(StoreName.CHAT, {
//   newMessageList: (newMessageList: unknown) => {
//     if (Array.isArray(newMessageList)) {
//       newMessageList.forEach(message => TUINotification.notify(message));
//     }
//   },
// });

export { SDKAppID, secretKey };
